/************************************************************************/
/*                                                                      */
/*             ,     ..        */
/*                   ,   ,   .               */
/*                                                                      */
/************************************************************************/

#include "error.h"
#include <exception>
#include <stdio.h>
#include <string.h>

//      .
//     main(),  
//      .

void Error(const char* fmt, ...)
{
	char szBuf[1024] = {0};
	va_list args;
	va_start(args, fmt);
	_vsnprintf(szBuf, sizeof(szBuf) - 1, fmt, args);
	va_end(args);
	throw std::exception(szBuf);
}

void ErrorVarArg(const char* pszFileName, 
				 int nLine, 
				 int nCol, 
				 const char* fmt, 
				 va_list args)
{
	char szBuf[2048] = {0};
	sprintf(szBuf, "%s(%d,%d): ", pszFileName, nLine, nCol);
	int nLen = strlen(szBuf);
	_vsnprintf(szBuf + nLen, sizeof(szBuf) - 1 - nLen, fmt, args);
	Error("%s", szBuf);
}
