/************************************************************************/
/*                                                                      */
/*             ,     ..        */
/*                   ,   ,   .               */
/*                                                                      */
/************************************************************************/

#pragma once

#include <stdarg.h>

//      .
//     main(),  
//      .

void Error(const char* fmt, ...);
void ErrorVarArg(const char* pszFileName, int nLine, int nCol, const char* fmt, va_list args);

//    

//   
#define E_OPEN_FILE			"cannot open file '%s' (%d)"
#define E_NO_AND			"expected '&'"
#define E_NO_OR				"expected '|'"
#define E_NO_XOR			"expected '^'"
#define E_INVALID_SYM		"invalid symbol 0x%02X"
#define E_NUM_TOO_LONG		"number too long"
#define E_INVALID_NUM		"invalid number '%s'"
#define E_STR_NEWLINE		"newline in string constant"
#define E_EOF				"unexpected EOF"
#define E_STR_TOO_LONG		"string too long"
#define E_INVALID_ESC		"invalid escape sequence"
#define E_ID_TOO_LONG		"identifier too long"

//   
#define E_EXPECTED			"expected %s"
#define E_DUP_FN			"function '%s' already defined"
#define E_DUP_ARG			"duplicate argument '%s'"
#define E_NO_EXPR			"expected expression"

//  
#define E_NO_MAIN			"no 'main' function"
#define E_EMPTY_VAR			"variable '%s' not initialized"
#define E_INV_STMT			"invalid statement type 0x%02X"
#define E_INV_OP			"invalid operator type 0x%02X"
#define E_INV_BREAK			"illegal 'break' without 'while'"
#define E_INV_CONTINUE		"illegal 'continue' without 'while'"
#define E_INV_RETURN		"illegal 'return' without function"
#define E_CODESTACK_DEEP	"code stack overflow"
#define E_INV_OPTYPE		"invalid operand type"
#define E_INV_TYPEOP		"invalid operand type 0x%02X for operation '%s'"
#define E_DIVIDE			"divide error"
#define E_LVALUE			"l-value required"
#define E_NO_FUNC			"function '%s' not defined"
#define E_ARG_COUNT			"function '%s' does not take %d arguments"
#define E_MATH_ERR			"error in math function '%s'"
