/************************************************************************/
/*                                                                      */
/*             ,     ..        */
/*                   ,   ,   .               */
/*                                                                      */
/************************************************************************/

#pragma warning(disable:4786)

#include "lexer.h"
#include "parser.h"
#include "interp.h"

int main(int argc, char* argv[])
{
	//       
	if (argc < 2)
	{
		printf("ibasic <filename>\n");
		return -1;
	}

	try
	{
		Program prog;
		prog.sFileName = argv[1];
		
		//  
		CLexer lexer(&prog);
		
		//  
		CParser parser(&prog, &lexer);
		parser.Parse();
		
		// 
		CInterpreter interp(&prog);
		while (interp.DoStep());
	}
	catch (exception& e)
	{
		//    
		printf("%s\n", e.what());
		return -1;
	}
	catch (...)
	{
		//  
		printf("Error: internal exception occured\n");
		return -1;
	}

	return 0;
}
