/************************************************************************/
/*                                                                      */
/*             ,     ..        */
/*                   ,   ,   .               */
/*                                                                      */
/************************************************************************/

#pragma once

#include <istream>
#include "token.h"
#include "program.h"

#define MAX_IDENTIFIER		32
#define MAX_STR_CONST		1024

using namespace std;

/************************************************************************/
/*                                          */
/************************************************************************/

class CLexer
{
private:
	//   
	enum eLexerState
	{
		stNormal,
		stComment1,
		stComment2,
		stNumber,
		stNumber2,
		stNumber3,
		stNumber4,
		stNumber5,
		stNumber6,
		stString,
		stString2,
		stString3,
		stIdent
	};

	Program*	m_pProg;
	istream*	m_pStream;
	int			m_nLine;
	int			m_nCol;
	char		m_cLast;
	bool		m_bUnget;

	//     
	char get()
	{
		if (m_bUnget)
		{
			m_bUnget = false;
			return m_cLast;
		}
		m_nCol++;
		return m_cLast = m_pStream->get();
	}
	//    
	void unget()
	{
		m_bUnget = true;
	}

	//         
	void Error(const char* fmt, ...);
	//     
	CToken NumberToken(char* szBuf, bool bIsFloat);

public:
	CLexer(Program* pProg);
	~CLexer();
	//   
	CToken GetToken();
};
