/************************************************************************/
/*                                                                      */
/*             ,     ..        */
/*                   ,   ,   .               */
/*                                                                      */
/************************************************************************/

#pragma once

#include <list>

/************************************************************************/
/*     -              */
/************************************************************************/

class CStrTable
{
private:
	typedef std::list<char*> STRINGLIST;
	STRINGLIST m_Strings;

public:
	~CStrTable()
	{
		Clear();
	}
	//    
	const char* Add(const char* str)
	{
		char* p = strdup(str);
		m_Strings.push_back(p);
		return p;
	}
	//  
	void Clear()
	{
		STRINGLIST::iterator it = m_Strings.begin();
		for (; it != m_Strings.end(); ++it)
		{
			free (*it);
		}
	}
};
